2019-07-15 leetcode two sum 两数

2019-07-17  本文已影响0人  mister_eric

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。

你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。

示例:

给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9

所以返回 [0, 1]

import java.util.HashMap;

import java.util.Map;

class TwoSum {

    public static void main(String[] args) {

        int nums[] = {2,7,11,15};

        int target = 17;

        int res[] = twoSum(nums, target);

        System.out.println(res[0] + ", " + res[1]);

    }

    public static int[] twoSum(int[] nums, int target) {

        Map<Integer,Integer> map = new HashMap<>();

        for(int i = 0; i < nums.length; i++){

            /**

            * 遍历一轮就可以实现

            * 遍历时候:将元素的值,作为key 放到hashmap中,value存放元素在数组中的位置

            * 在寻找对应元素的时候,也就变成在hashmap中寻找。节约时间

            */

            int annother = target - nums[i];

            if(map.containsKey(annother)){

                return new int[]{map.get(annother),i};

            }

            map.put(nums[i], i);

        }

        throw new IllegalArgumentException("no two sum solution");

    }

}

上一篇下一篇

猜你喜欢

热点阅读